package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERTaggedObject;

public class SignerIdentifier extends ASN1Encodable {
   private DEREncodable id;

   public SignerIdentifier(IssuerAndSerialNumber id) {
      this.id = id;
   }

   public SignerIdentifier(ASN1OctetString id) {
      SignerIdentifier var10000 = this;
      super();
      DERTaggedObject var2;
      var2 = new DERTaggedObject.<init>(false, 0, id);
      var10000.id = var2;
   }

   public SignerIdentifier(DERObject id) {
      this.id = id;
   }

   public static SignerIdentifier getInstance(Object o) {
      if (o != null && !(o instanceof SignerIdentifier)) {
         if (o instanceof IssuerAndSerialNumber) {
            return new SignerIdentifier((IssuerAndSerialNumber)o);
         } else if (o instanceof ASN1OctetString) {
            return new SignerIdentifier((ASN1OctetString)o);
         } else if (o instanceof DERObject) {
            return new SignerIdentifier((DERObject)o);
         } else {
            throw new IllegalArgumentException("Illegal object in SignerIdentifier: " + o.getClass().getName());
         }
      } else {
         return (SignerIdentifier)o;
      }
   }

   public boolean isTagged() {
      return this.id instanceof ASN1TaggedObject;
   }

   public DEREncodable getId() {
      DEREncodable var1;
      return (DEREncodable)((var1 = this.id) instanceof ASN1TaggedObject ? ASN1OctetString.getInstance((ASN1TaggedObject)var1, false) : var1);
   }

   public DERObject toASN1Object() {
      return this.id.getDERObject();
   }
}
